# /!\ NE PAS MODIFIER  CE CODE  /!\

# Structure pour le type Complexe
class Complexe:
  
    def __init__(self,a=0,b=0):
        self.re=a
        self.im=b
        
    def __repr__(self):
        if self.re==0:
            if self.im==0:
                return "0"
            return repr(self.im)+" i"
        else:
            if self.im==0:
                return repr(self.re)
            if self.im<0:
                return repr(self.re)+" - "+repr(-self.im)+" i"
            return repr(self.re)+" + "+repr(self.im)+" i"
    
    def copy(self):
        return Complex(self.re,self.im)
       
# Affiche une matrice
def affiche(M):
    for ligne in M:
        print('[',end='')
        for coeff in ligne:
            print('\t\t',coeff,end='')
        print('\t\t]')
        
# Retourne le nombre de lignes de la matrice M
def nombre_lignes(M):
    return len(M)

# Retourne le nombre de colonnes de la matrice M
def nombre_colonnes(M):
    return len(M[0])

# Créer la matrice nulle à l lignes et c colonnes
def creer_matrice(l,c):
    res=[]
    for i in range(l):
        res.append([0]*c)
    return res
    
# Tableaux tab et tab2
tab=[5,2,3,7,8,0,6,8,2,1,0,3,10,5,2,-1,6,5,11,2]

tab2=[2,5,3,1,3,6]

# Matrice A, B et C
A=[[1,2,1],[0,-1,4]]

B=[[0,0,1],[0,1,0]]

C=[[-1,1],[1,-1],[0,2]]

# FAIRE VOS EXERCICES ICI 

# **************
# * EXERCICE 2 *
# **************

print()
print("==> Exercice 2")
print()


def dire_bonjour():
    print("Bonjour le monde !")

# **************
# * EXERCICE 4 *
# **************

print()
print("==> Exercice 4")
print()

def res(exp,M):
    res=0
    for i in range(1,M+1):
        res=res+i**exp
    return res

print("La valeur de res(3,10) est",res(3,10))

# **************
# * EXERCICE 5 *
# **************

print()
print("==> Exercice 5")
print()


# 1. Fibonacci version récursive

def fibo_rec(n):
    if n<0:
        print("Erreur")
        return -1
    if n==0:
        return 0
    if n==1:
        return 1
    return fibo_rec(n-1)+fibo_rec(n-2)

# 2. Fibonacci version non récursive

def fibo(n):
    F0=0
    F1=1
    if n<0:
        return -1
    if n==0:
        return 0
    if n==1:
        return 1
    while n>=2:
        Fn=F0+F1
        F0=F1
        F1=Fn
        n=n-1
    return Fn
        
    
# 3. Teste des fonctions

print("Calcule de F_10, F_20 et F_30 par fibo_rec : ",fibo_rec(10),fibo_rec(20),fibo_rec(30))

print("Calcule de F_10, F_20 et F_30 par fibo : ",fibo(10),fibo(20),fibo(30))
    
# **************
# * EXERCICE 6 *
# **************

print()
print("==> Exercice 6")
print()

# Retourne la racine carrée de a

def racine_carree(a):
    un=1
    while abs(un**2-a)>10**(-10):
        un=1/2*(un+a/un)
    return un

print("Une valeur approchée de racine(2) est",racine_carree(2))

# **************
# * EXERCICE 7 *
# **************

print()
print("==> Exercice 7")
print()

# 1. Additionne les complexes z1 et z2

def additionner(z1,z2):
    res=Complexe(0)
    res.re=z1.re+z2.re
    res.im=z1.im+z2.im
    return res

print("(1 - 3 i) + (2 + i) = ",additionner(Complexe(1,-3),Complexe(2,1)))

# 2. Multiplie les complexes z1 et z2

def multiplier(z1,z2):
    res=Complexe(0)
    res.re=z1.re*z2.re-z1.im*z2.im
    res.im=z1.re*z2.im+z1.im*z2.re
    return res
    
print("(1 - 3 i) * (2 + i) = ",multiplier(Complexe(1,-3),Complexe(2,1)))
    
# 3. Retourne le module du complexe z

def module(z):
    return racine_carree(z.re**2+z.im**2)
    
print("|2 + i| = ",module(Complexe(2,1)))
    
# **************
# * EXERCICE 8 *
# **************

print()
print("==> Exercice 8")
print()

# 1. Evalue ax^2+bx+c en le Complexe z

def evaluer(a,b,c,z): 
    coeff2=multiplier(z,z) #z^2
    coeff2=multiplier(Complexe(a),coeff2) #a.z^2
    coeff1=multiplier(Complexe(b),z) #b.z
    res=additionner(coeff2,coeff1) #a.z^2+b.z
    res=additionner(res,Complexe(c)) #a.z^2+b.z+c
    return res

# 2. Retourne les racines de ax^2+bx+c

def racines(a,b,c):
    delta=b**2-4*a*c
    if delta==0:
        r=-b/(2*a)
        return [Complexe(r)]
    if delta>0:
        r=(-b-racine_carree(delta))/(2*a)
        s=(-b+racine_carree(delta))/(2*a)
        return [Complexe(r),Complexe(s)]
    r=Complexe(-b/(2*a),-racine_carree(-delta)/(2*a))
    s=Complexe(-b/(2*a),racine_carree(-delta)/(2*a))
    return [r,s]
    

# 3. Teste des fonctions


print("Les racines de x^2-1 sont ",racines(1,0,-1))

print()
print("Les racines de x^2+2x+1 sont ",racines(1,2,1))

print()
print("Les racines de x^2+1 sont ",racines(1,0,1))

[r,s]=racines(1,-1,-1)
print()
print("Les racines de x^2-x-1 sont ",[r,s])
print("Verification : ",evaluer(1,-1,-1,r)," et ",evaluer(1,-1,-1,s))

[r,s]=racines(1,1,1)
print()
print("Les racines de x^2+x+1 sont ",[r,s])
print("Verification : ",evaluer(1,1,1,r)," et ",evaluer(1,1,1,s))


# **************
# * EXERCICE 9 *
# **************

print()
print("==> Exercice 9")
print()


# 1. Retourne le minimum d'un tableau

def min(t):
    m=t[0]
    for i in range(len(t)):
        if t[i]<m:
            m=t[i]
    return m
    
print("Le minimum de tab est ",min(tab))

# 2. Retourne la somme d'un tableau

def somme(t):
    res=0
    for i in range(len(t)):
        res=res+t[i]
    return res

print("Le somme de tab est ",somme(tab))

# 3. Retourne le nombre d'éléments pairs dans un tableau

def nombre_pairs(t):
    n=0
    for i in range(len(t)):
        if t[i]%2==0:
            n=n+1
    return n

print("Le nombre d'éléments pairs de tab est ",nombre_pairs(tab))


# ***************
# * EXERCICE 10 *
# ***************

print()
print("==> Exercice 10")
print()

# 2. Tir le tableau tab à l'aide du tri à bulle 

def tri_bulle(t):
    for j in range(len(t)):
        for i in range(len(t)-j-1):
            if t[i]>t[i+1]:
                temp=t[i]
                t[i]=t[i+1]
                t[i+1]=temp
                

# 3. Test du tri

tri_bulle(tab2)
print("Le tableau tab2 trié est : ",tab2)

tri_bulle(tab)
print("Le tableau tab trié est : ",tab)


# ***************
# * EXERCICE 11 *
# ***************

print()
print("==> Exercice 11")
print()

# 1. Teste si une matrice est nulle

def est_nulle(M):
    l=nombre_lignes(M)
    c=nombre_colonnes(M)
    for i in range(l):
        for j in range(c):
            if M[i][j]!=0:
                return False
    return True
    
print("Est nulle A : ",est_nulle(A))
print("Est nulle B : ",est_nulle(B))
print("Est nulle C : ",est_nulle(C))
print("Est nulle O_(2,3) : ",est_nulle(creer_matrice(2,3)))


    
# 2. Retourne la somme de matrices

def additionner_matrice(M,N):
    l=nombre_lignes(M)
    c=nombre_colonnes(N)
    if l!=nombre_lignes(N) or c!=nombre_colonnes(N):
        print("Somme impossible")
        return None
    res=creer_matrice(l,c)
    for i in range(l):
        for j in range(c):
            res[i][j]=M[i][j]+N[i][j]
    return res
    
    
print()
print("A + B => ")
affiche(additionner_matrice(A,B))

# 3. Retourne le produit du matrices

def multiplier_matrice(M,N):
    t=nombre_colonnes(M)
    if t!=nombre_lignes(N):
        print("Produit impossible")
        return None
    l=nombre_lignes(M)
    c=nombre_colonnes(N)
    res=creer_matrice(l,c)
    for i in range(l):
        for j in range(c):
            sum=0
            for k in range(t):
                sum=sum+M[i][k]*N[k][j]
            res[i][j]=sum
    return res
    
    
print()
print("C * A => ")
affiche(multiplier_matrice(C,A))

print()
print("C * B => ")
affiche(multiplier_matrice(C,B))
